      SUBROUTINE EXT_EUROPROFIL(KNBMESS,KNBMECR,CDTYPM,KNBWAG,
     &                          PLATN,PLATS,PLONO,PLONE,KPLEIN)
!-----------------------------------------------------------------------
!  auteur de revision : F. Guillaume
!  date de revision   : 17/03/2008
!  objet              : formats explicites d'ecriture dans OBSOUL
!                       pour mise en conofmite SOPRANO.
!=======================================================================
      IMPLICIT LOGICAL(L)

#include "oulan_pardimo.h"
#include "oulan_yomtomv.h"
#include "oulan_yompin.h"
#include "oulan_yomdirs.h"
#include "oulan_yomnbob.h"
#include "oulan_yomdate.h"
#include "oulan_yomcsts.h"

      PARAMETER ( JP_NBX_PAR = 10000  )

      CHARACTER  CLLAT            *  12 , CLLON                   *   12
      CHARACTER  CDTYPM           *  10 , CL_NULL                 *    5

      CHARACTER  CL_TYPE_MESS     * 20 , CL_VERS_MESS              * 20
      CHARACTER  CL_MIN_DATE      * 14 , CL_MAX_DATE               * 14
      CHARACTER  CL_AUTORISATION  * 30
      CHARACTER  CL_LAST_ARRIVED  *  1 , CL_LISTE_PARAM(1)         * 15
      CHARACTER  CL_LISTE_STAT(1) *  4 , CL_DONNEES(5,KNBMESS)     * 80
      INTEGER    I_PAS_DE_TPS , I_NB_PARAM , I_TYPE_SORTIE , I_NBRE_STAT
      INTEGER    I_CQ_BDM(1300,KNBMESS),I_CODE_RETOUR_EXT , I_NB_MESS
      REAL       Z_DONNEES(1300,KNBMESS)

      REAL  DL_MIN_LAT , DL_MAX_LAT
      REAL  DL_MIN_LON , DL_MAX_LON

      CHARACTER  CLINDIC          * 12
      INTEGER    IVNM(JP_NBX_PAR),IFLG(JP_NBX_PAR),INCQ(0:3)
      REAL       ZPOB(JP_NBX_PAR),ZPRL(JP_NBX_PAR),ZVAR(JP_NBX_PAR)


! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      character entete * 84, wagon_prov * 34
      character wagon  * 34, fmt_final * 117
! ----------------------------------------------------------------------


#include "oulan_yombitu.h"

! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      entete = "(I4,1X,I2,1X,I9,1X,F9.5,1X,F10.5,1X,A12,1X,I8,1X,I6,1X"
      entete = trim(adjustl(entete)) // ",ES12.5,1X,I5,1X,I7,1X,I7,1X,"
      wagon_prov = "(I5,'(1X,I3,1X,3(ES12.5,1X),I11)')"                       
! ----------------------------------------------------------------------

      KNBMECR = 0
      KPLEIN  = 0

      CL_NULL  = 'NULL'//CHAR(0)

      INCQ(0) = 0
      INCQ(1) = 2
      INCQ(2) = 3
      INCQ(3) = 1

      IZERO   = 0
      ICQUN   = 1

!-----------------------------------------------------------------------

!  Initialisations des arguments de la fonction d'extraction
!  ---------------------------------------------------------

      CL_TYPE_MESS( 1:10) = CDTYPM
      CL_TYPE_MESS(11:20) = '          '
      CL_VERS_MESS        = '%                   '
      CL_MIN_DATE         = CDATDEB(2)
      CL_MAX_DATE         = CDATFIN(2)
      CL_AUTORISATION     = 'OPER                          '
      CL_LAST_ARRIVED     = 'Y'
      CL_LISTE_STAT(1)    = 'NULL'
      CL_LISTE_PARAM(1)   = 'NULL           '

      I_PAS_DE_TPS        = 0
      I_NB_PARAM          = 0
      I_TYPE_SORTIE       = 3
      I_NBRE_STAT         = 0
      I_NB_MESS           = KNBMESS

      DL_MIN_LAT          = PLATS
      DL_MAX_LAT          = PLATN
      DL_MIN_LON          = PLONO
      DL_MAX_LON          = PLONE

      CL_DONNEES          = ' '
      Z_DONNEES           = RABSI
      I_CQ_BDM            = NABSI

!-----------------------------------------------------------------------

!  Extraction
!  ----------

      PRINT *,' '
      PRINT *,' Extraction des ',CDTYPM
      PRINT *,' '

      CALL RDLLTDOMAINDECOD( CL_TYPE_MESS , CL_VERS_MESS , CL_MIN_DATE ,
     &                       CL_MAX_DATE , CL_AUTORISATION ,
     &                       CL_LAST_ARRIVED , I_PAS_DE_TPS ,
     &                       CL_NULL , I_NB_PARAM , Z_DONNEES ,
     &                       CL_DONNEES , CL_NULL , I_TYPE_SORTIE ,
     &                       I_NB_MESS , DL_MIN_LAT , DL_MAX_LAT ,
     &                       DL_MIN_LON , DL_MAX_LON , CL_NULL ,
     &                       I_NBRE_STAT , I_CODE_RETOUR_EXT )

      PRINT *,' '
      PRINT *,' Fin de l''extraction '
      PRINT *,' '

         IF ( I_CODE_RETOUR_EXT.NE.0 .AND.
     &        I_CODE_RETOUR_EXT.NE.1       ) THEN
            PRINT 101,CDTYPM,I_CODE_RETOUR_EXT
 101        FORMAT(/,' Probleme lors de l''extraction des ',A10,
     &             ' I_CODE_RETOUR_EXT = ',I2,/)
            RETURN
         ENDIF

      IF ( I_NB_MESS.EQ.KNBMESS ) KPLEIN = I_NB_MESS
      IF ( NINIT.EQ.1 ) RETURN

!-----------------------------------------------------------------------

!  Traitements
!  -----------

      OBS_BCLE: DO JO=1,I_NB_MESS
        IF ( LCUTOFF .AND. 
     &       CL_DONNEES(2,JO)(1:14).GT.CDATFIN(4) ) CYCLE OBS_BCLE
        IRLN    = NABSO
        IOTP    = NABSO
        IOCH    = NABSO
        ZLAT    = RABSO
        ZLON    = RABSO
        IDAT    = NABSO
        IETM    = NABSO
        ZALT    = RABSO
        INLV    = NABSO
        IRFL    = 11111
        ISTD    = 0
        CLINDIC = " '        ' "
        CLLAT   = "            "
        CLLON   = "            "
        ICQLAT  = 1
        ICQLON  = 1
        ICQDAT  = 1
        ICQETM  = 1
        ICQALT  = 1

        DO JA=1,JP_NBX_PAR
          IVNM(JA) = NABSO
          ZPOB(JA) = RABSO
          ZPRL(JA) = RABSO
          ZVAR(JA) = RABSO
          IFLG(JA) = NABSO
        ENDDO

!  Saisie de la locomotive

        IOTP = NPILOT
        ZLAT = Z_DONNEES(16,JO)
        ZLON = Z_DONNEES(17,JO)
        IF ( I_CQ_BDM(16,JO).EQ.2 .OR. I_CQ_BDM(17,JO).EQ.2 )
     &    CYCLE OBS_BCLE
        WRITE (CLLAT(2:11),'(F10.5)') ZLAT
        WRITE (CLLON(2:11),'(F10.5)') ZLON
        IOCH    = 0
        ITYPMES = 15
        IF (Z_DONNEES(19,JO).NE.RABSI) ITYPMES = NINT(Z_DONNEES(19,JO))
        CALL OULAN_CAROBS(IOTP,CDTYPM,ITYPMES,IZERO,IZERO,ZLAT,IOCH)
        IDAT = NINT( Z_DONNEES(11,JO) ) * 10000  +
     &         NINT( Z_DONNEES(12,JO) ) * 100    +
     &         NINT( Z_DONNEES(13,JO) )
        IETM = NINT( Z_DONNEES(14,JO) ) * 10000  +
     &         NINT( Z_DONNEES(15,JO) ) * 100

        IF ( Z_DONNEES(1,JO).NE.RABSI ) THEN
          IVALCL = NINT( Z_DONNEES(1,JO) )
          INOCL  = IVALCL / 1000
          ILNCL  = MOD( IVALCL , 1000 )
          IF ( ILNCL.GE.8 ) THEN
            CLINDIC(3:10) = CL_DONNEES(INOCL,JO)(1:8)
          ELSE
            CLINDIC(3:2+ILNCL) = CL_DONNEES(INOCL,JO)(1:ILNCL)
          ENDIF
        ENDIF
        ZALT = Z_DONNEES(18,JO)

        IF ( I_CQ_BDM(16,JO).NE.NABSI ) ICQLAT = INCQ(I_CQ_BDM(16,JO))
        IF ( I_CQ_BDM(17,JO).NE.NABSI ) ICQLON = INCQ(I_CQ_BDM(17,JO))
        IF ( I_CQ_BDM(18,JO).NE.NABSI ) ICQALT = INCQ(I_CQ_BDM(18,JO))
        IF ( I_CQ_BDM(11,JO).NE.NABSI .AND. I_CQ_BDM(12,JO).NE.NABSI
     &       .AND. I_CQ_BDM(13,JO).NE.NABSI )
     &    ICQDAT = MAX0( INCQ(I_CQ_BDM(11,JO)) ,
     &                   MAX0( INCQ(I_CQ_BDM(12,JO)) ,
     &                         INCQ(I_CQ_BDM(13,JO)) ) )
        IF ( I_CQ_BDM(14,JO).NE.NABSI .AND. I_CQ_BDM(15,JO).NE.NABSI )
     &    ICQETM = MAX0(INCQ(I_CQ_BDM(14,JO)),INCQ(I_CQ_BDM(15,JO)))
        IRFL = ICQALT*10000 + ICQETM*1000 + ICQDAT*100 + ICQLON*10 +
     &         ICQLAT
!
        IF ( Z_DONNEES(8,JO).NE.RABSI )
     &    ISTD = INT(Z_DONNEES(8,JO)+REPSILON)

!  Saisie des wagons

!  composition du code qualite (IFLG) :

!     bits 1 et 2   code qualite coordonnee verticale
!     bits 3 et 4   code qualite parametre mesure
!     bit    12     coordonnee verticale en Pascals
!     bit    13     coordonnee verticale en metres

        INBNIV = INT( Z_DONNEES(29,JO) )
        IF ( INBNIV.EQ.0 .OR. INBNIV.EQ.NABSI ) CYCLE OBS_BCLE

        INBP = 0

        PAR_BCLE: DO JN=1,INBNIV
          ID    = 29 + (JN-1)*10
          ICQCV = 3
          ICQPA = 3

          IF ( Z_DONNEES(ID+1,JO).NE.RABSI .AND.
     &         I_CQ_BDM(ID+1,JO).NE.2            ) THEN
            IPOCV  = 13
            IF ( I_CQ_BDM(ID+1,JO).NE.NABSI ) ICQCV = I_CQ_BDM(ID+1,JO)
          ELSE
            CYCLE PAR_BCLE
          ENDIF

!  direction et force du vent

          IF ( Z_DONNEES(ID+4,JO).NE.RABSI  .AND.
     &         Z_DONNEES(ID+5,JO).NE.RABSI  .AND.
     &         Z_DONNEES(ID+4,JO).NE.400.   .AND.
     &         I_CQ_BDM(ID+4,JO).NE.2       .AND.
     &         I_CQ_BDM(ID+5,JO).NE.2       .AND.
     &         INT(Z_DONNEES(ID+3,JO)).EQ.0       ) THEN
            INBP = INBP + 1
            IVNM(INBP) = NVNUMB(1)
            ZPOB(INBP) = Z_DONNEES(ID+1,JO)
            ZPRL(INBP) = Z_DONNEES(ID+5,JO)
            ZVAR(INBP) = Z_DONNEES(ID+4,JO)
            IF ( I_CQ_BDM(ID+4,JO).NE.NABSI ) ICQPA = I_CQ_BDM(ID+4,JO)
            IFLG(INBP) = 0
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV, 1)
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA, 3)
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,IPOCV)
          ENDIF
!
        ENDDO PAR_BCLE
!
        INLV = INBP
        IRLN = NCILET + INLV*NCILBO

!  Copie de l'observation sur le fichier d'obs.

        IF ( INBP.GT.0 ) THEN

           write(wagon,fmt=wagon_prov) INBP
	   fmt_final = trim(adjustl(entete))//trim(adjustl(wagon))//")"

          WRITE (NULOBI,fmt_final) IRLN,IOTP,IOCH,ZLAT,ZLON,CLINDIC,
     &                     IDAT,IETM,ZALT,INLV,IRFL,ISTD,
     &                     (IVNM(J),ZPOB(J),ZPRL(J),ZVAR(J),
     &                     IFLG(J),J=1,INBP)
          KNBMECR = KNBMECR + 1
          KNBWAG  = KNBWAG + INBP

          IF ( L_GEOPOINTS ) THEN
            ITPM = MOD( IOCH , 1000 )
            WRITE (NULGEO,'(F11.5,F11.5,I5)') ZLON,ZLAT,ITPM
          ENDIF
        ENDIF

      ENDDO OBS_BCLE

!-----------------------------------------------------------------------

      RETURN
      END
