      SUBROUTINE EXT_TOVSHIRS(CD_CODPRO,KNBMESS,KNBMECR,CDTYPM,KNBWAG,
     &                        PLATN,PLATS,PLONO,PLONE,KPLEIN)
!-----------------------------------------------------------------------
!  auteur de revision : F. Guillaume
!  date de revision   : 17/03/2008
!  objet              : formats explicites d'ecriture dans OBSOUL
!                       pour mise en conofmite SOPRANO.
!=======================================================================

      IMPLICIT LOGICAL(L)

#include "oulan_pardimo.h"
#include "oulan_yomtomv.h"
#include "oulan_yompin.h"
#include "oulan_yomdirs.h"
#include "oulan_yomnbob.h"
#include "oulan_yomdate.h"
#include "oulan_yomcsts.h"

      PARAMETER ( JP_NBX_PAR = 25      , JP_DIM_STRUCT = 170          )

      CHARACTER  CLLAT            * 12 , CLLON                   *   12
      CHARACTER  CDTYPM           * 10 , CD_CODPRO               *    3
      CHARACTER CL_NULL           *  5

      CHARACTER  CL_TYPE_MESS     * 20 , CL_VERS_MESS            *   20
      CHARACTER  CL_MIN_DATE      * 14 , CL_MAX_DATE             *   14
      CHARACTER  CL_LAST_ARRIVED  *  1 , CL_LISTE_PARAM(1)       *   15
      CHARACTER  CL_LISTE_STAT(1) *  4 , CL_DONNEES(5,KNBMESS)   *   80
      CHARACTER  CL_FROM          *  1 , CL_ORDER                *    1
      CHARACTER  CL_BASE          *  1 , CL_WHERE                * 1023
      CHARACTER  CL_AUTORISATION  * 30
!      CHARACTER  CL_MIN_LAT       *  3 , CL_MAX_LAT                *  3
!      CHARACTER  CL_MIN_LON       *  4 , CL_MAX_LON                *  4
      CHARACTER  CL_MIN_LAT       *  9 , CL_MAX_LAT                *  9
      CHARACTER  CL_MIN_LON       * 10 , CL_MAX_LON                * 10
      INTEGER    I_PAS_DE_TPS , I_NB_PARAM , I_TYPE_SORTIE , I_NBRE_STAT
      INTEGER    I_CODE_RETOUR_EXT , I_NB_MESS
      REAL       Z_DONNEES(JP_DIM_STRUCT,KNBMESS)

      REAL  DL_MIN_LAT , DL_MAX_LAT
      REAL  DL_MIN_LON , DL_MAX_LON

      CHARACTER  CLINDIC*12,CLSATOUT(10)*3,CLNBSATOUT(10)*6
      CHARACTER  CLPROD*9,CLSOUL*9,CLSATTEMPO*3
      INTEGER    ICODM(KNBMESS),IVNM(JP_NBX_PAR),IFLG(JP_NBX_PAR)
      INTEGER    INOSAT(30),INBSAT(30),INBSATOUT(10)
      REAL       ZPOB(JP_NBX_PAR),ZPRL(JP_NBX_PAR),ZVAR(JP_NBX_PAR)

! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      character entete * 84, wagon_prov * 34
      character wagon  * 34, fmt_final * 117
! ----------------------------------------------------------------------


#include "oulan_yombitu.h"

! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      entete = "(I4,1X,I2,1X,I9,1X,F9.5,1X,F10.5,1X,A12,1X,I8,1X,I6,1X"
      entete = trim(adjustl(entete)) // ",ES12.5,1X,I5,1X,I7,1X,I7,1X,"
      wagon_prov = "(I5,'(1X,I3,1X,3(ES12.5,1X),I11)')"                       
! ----------------------------------------------------------------------

      CL_NULL  = 'NULL'//CHAR(0)

      IZERO         = 0
      ICQUN         = 1

      INUMST        = 0
      INBEXTOT      = 0
      INBRETOT      = 0
      INOSAT        = 0
      INBSAT        = 0

      CLNBSATOUT    = '      '
      CLSATOUT      = '   '
      INBSATOUT     = 0

      I_NB_SAT      = 0
      I_NB_SAT_OUT  = 0

      IF ( CD_CODPRO.EQ.'211' ) THEN
        CLPROD = 'Lannion  '
        CLSOUL = '-------  '
      ELSE IF ( CD_CODPRO.EQ.' 74' ) THEN
        CLPROD = 'Bracknell'
        CLSOUL = '---------'
      ELSE IF ( CD_CODPRO.EQ.' 98' ) THEN
        CLPROD = 'CEPMMT   '
        CLSOUL = '------   '
      ELSE IF ( CD_CODPRO.EQ.'254' ) THEN
        CLPROD = 'EUMETSAT '
        CLSOUL = '-------- '
      ENDIF

!-----------------------------------------------------------------------

!  Initialisations des arguments de la fonction d'extraction
!  ---------------------------------------------------------

      CL_TYPE_MESS( 1:10) = CDTYPM
      CL_TYPE_MESS(11:20) = '          '
      CL_VERS_MESS        = '%                   '
      CL_MIN_DATE         = CDATDEB(2)
      CL_MAX_DATE         = CDATFIN(2)
      CL_AUTORISATION     = 'OPER                          '
      CL_LAST_ARRIVED     = 'Y'
      CL_LISTE_STAT(1)    = 'NULL'
      CL_LISTE_PARAM(1)   = 'NULL           '

      CL_WHERE            = ' '
      CL_FROM             = '?'
      CL_ORDER            = '?'
      CL_BASE             = 'Y'

      WRITE(CL_MIN_LAT(1:9),'(F9.5)')  PLATS
      WRITE(CL_MAX_LAT(1:9),'(F9.5)')  PLATN
      WRITE(CL_MIN_LON(1:10),'(F10.5)') PLONO
      WRITE(CL_MAX_LON(1:10),'(F10.5)') PLONE
      CL_WHERE(001:044) = 'and ((((+000.00000>=+000.00000 and ((MINLON<'
      CL_WHERE(045:088) = 'MAXLON and MINLON<=+000.00000 and MAXLON>=+0'
      CL_WHERE(089:132) = '00.00000) or (MINLON>MAXLON and (MINLON<=+00'
      CL_WHERE(133:176) = '0.00000 or MAXLON>=+000.00000)))) or (+000.0'
      CL_WHERE(177:220) = '0000<+000.00000 and ((MINLON<=MAXLON and (MI'
      CL_WHERE(221:264) = 'NLON<=+000.00000 or MAXLON>=+000.00000)) or '
      CL_WHERE(265:308) = 'MINLON>MAXLON))) and (MINLAT<=+00.00000 and '
      CL_WHERE(309:352) = 'MAXLAT>=+00.00000)) or MINLON is NULL or MAX'
      CL_WHERE(353:396) = 'LON is NULL or MINLAT is NULL or MAXLAT is N'
      CL_WHERE(397:400) = 'ULL)'

      CL_WHERE(009:018) =CL_MAX_LON(1:10)
      CL_WHERE(021:030) =CL_MIN_LON(1:10)
      CL_WHERE(064:073) =CL_MAX_LON(1:10)
      CL_WHERE(087:096) =CL_MIN_LON(1:10)
      CL_WHERE(130:139) =CL_MAX_LON(1:10)
      CL_WHERE(152:161) =CL_MIN_LON(1:10)
      CL_WHERE(171:180) =CL_MAX_LON(1:10)
      CL_WHERE(182:191) =CL_MIN_LON(1:10)
      CL_WHERE(227:236) =CL_MAX_LON(1:10)
      CL_WHERE(249:258) =CL_MIN_LON(1:10)
      CL_WHERE(295:303) =CL_MAX_LAT(1:9)
      CL_WHERE(317:325) =CL_MIN_LAT(1:9)
      CL_WHERE(401:422) = ' AND LLTBUFR_VAL IN ('''
      ID = 422
      DO J=1,MNBSATSEL(N_TOVSHIRS)
        WRITE (CLSATTEMPO(1:3),'(I3)') MNOSATSEL(N_TOVSHIRS,J)
	CLSATTEMPO = ADJUSTL(CLSATTEMPO)
	CL_WHERE(ID+1:ID+LEN_TRIM(CLSATTEMPO)) = CLSATTEMPO
	ID = ID+LEN_TRIM(CLSATTEMPO)
        IF ( J.LT.MNBSATSEL(N_TOVSHIRS) ) THEN
          CL_WHERE(ID+1:ID+3) = ''','''
          ID = ID + 3
        ELSE
          CL_WHERE(ID+1:ID+2) = ''')'
	  ID = ID + 2
        ENDIF
      ENDDO
      CL_WHERE(ID+1:ID+19) = ' AND PROD_ORI = 000'
      CL_WHERE(ID+17:ID+19) = CD_CODPRO(1:3)
      ID = ID + 19
      IF ( LCUTOFF) THEN
         CL_LAST_ARRIVED = 'N'
         CL_WHERE(ID+1:ID+20)  = ' AND DATE_INSERT < '''
	 CL_WHERE(ID+21:ID+34)= CDATFIN(4)
	 CL_WHERE(ID+35:ID+37) = ''' '
      ENDIF
      I_PAS_DE_TPS        = 0
      I_NB_PARAM          = 0
      I_TYPE_SORTIE       = 3
      I_NBRE_STAT         = 0
      I_NB_MESS           = KNBMESS

      DL_MIN_LAT          = -90.
      DL_MAX_LAT          =  90.
      DL_MIN_LON          = -180.
      DL_MAX_LON          =  180.

      CL_DONNEES          = ' '
      Z_DONNEES           = RABSI

      KNBMECR = 0
      KPLEIN  = 0
      print *,CL_WHERE
!-----------------------------------------------------------------------

!  Extraction
!  ----------

      PRINT *,' '
      PRINT *,' Extraction des ',CDTYPM
      PRINT *,' '

      CALL RDLLTDOMCLAUSE(
     &  CL_TYPE_MESS    , CL_VERS_MESS    , CL_MIN_DATE  , CL_MAX_DATE ,
     &  CL_AUTORISATION , CL_LAST_ARRIVED , I_PAS_DE_TPS , CL_NULL     ,
     &  I_NB_PARAM      , Z_DONNEES       , CL_DONNEES   , CL_NULL     , 
     &  I_TYPE_SORTIE   , I_NB_MESS       , DL_MIN_LAT   , DL_MAX_LAT  ,
     &  DL_MIN_LON      , DL_MAX_LON      , CL_NULL      , I_NBRE_STAT ,
     &  CL_FROM         , CL_WHERE        , CL_ORDER     , CL_BASE     ,
     &  I_CODE_RETOUR_EXT )

      PRINT *,' '
      PRINT *,' Fin de l''extraction '
      PRINT *,' '

      IF ( I_CODE_RETOUR_EXT.NE.0 .AND.
     &     I_CODE_RETOUR_EXT.NE.1       ) THEN
        PRINT 101,CDTYPM,I_CODE_RETOUR_EXT
 101    FORMAT(/,' Probleme lors de l''extraction des ',A10,
     &         ' I_CODE_RETOUR_EXT = ',I2,/)
        RETURN
      ENDIF

      IF ( I_NB_MESS.EQ.KNBMESS ) KPLEIN = I_NB_MESS
      IF ( NINIT.EQ.1 ) RETURN

!-----------------------------------------------------------------------

!  Traitement des messages suivant echantillonage ou non
!  -----------------------------------------------------

      BOUCLE_MESSAGE: DO JO=1,I_NB_MESS
        IF (Z_DONNEES(27,JO) > PLATN .OR.
     &      Z_DONNEES(27,JO) < PLATS .OR.
     &      Z_DONNEES(28,JO) > PLONE .OR.
     &      Z_DONNEES(28,JO) < PLONO) CYCLE BOUCLE_MESSAGE

!  selection en fonction de l'heure d'insertion dans la BDM, si necessaire
!  -----------------------------------------------------------------------
!        IF ( LCUTOFF .AND. 
!     &       CL_DONNEES(1,JO)(1:14).GT.CDATFIN(4) ) CYCLE BOUCLE_MESSAGE
        INBEXTOT = INBEXTOT + 1

!  selection 1 sur NHIRSSAUT+1
!  ---------------------------

        ILSAUTE  = 0
        IF ( LHIRSECH ) THEN
          Z_SAUT = NHIRSSAUT + 1
          INOL   = MOD( Z_DONNEES(16,JO) , Z_SAUT )
          INOC   = MOD( Z_DONNEES(17,JO) , Z_SAUT )
          IF ( INOL*INOC.NE.1 ) ILSAUTE = 1
        ENDIF

        IRLN     = NABSO
        IOTP     = NABSO
        IOCH     = NABSO
        ZLAT     = RABSO
        ZLON     = RABSO
        IDAT     = NABSO
        IETM     = NABSO
        ZALT     = RABSO
        INLV     = NABSO
        IRFL     = 11111
        ISTD     = 0
        CLINDIC  = " '        ' "
        CLLAT    = '            '
        CLLON    = '            '
        ICQLAT   = 1
        ICQLON   = 1
        ICQDAT   = 1
        ICQETM   = 1
        ICQALT   = 1

        DO JA=1,JP_NBX_PAR
          IVNM(JA) = NABSO
          ZPOB(JA) = RABSO
          ZPRL(JA) = RABSO
          ZVAR(JA) = RABSO
          IFLG(JA) = NABSO
        ENDDO

!  Saisie de la locomotive

        IOTP = NSATEM
        ZLAT = Z_DONNEES(27,JO)
        ZLON = Z_DONNEES(28,JO)
        IF ( Z_DONNEES(27,JO).EQ.RABSI .OR. Z_DONNEES(28,JO).EQ.RABSI )
     &    CYCLE BOUCLE_MESSAGE
        WRITE (CLLAT(2:11),'(F10.5)') ZLAT
        WRITE (CLLON(2:11),'(F10.5)') ZLON
        ICODPRO = NINT(Z_DONNEES(2,JO))
        IF ( ICODPRO.NE. 74 .AND. ICODPRO.NE. 98 .AND.
     &       ICODPRO.NE.211 .AND. ICODPRO.NE.254       ) ICODPRO = 0

        CALL OULAN_CAROBS(IOTP,CDTYPM,ICODPRO,IZERO,IZERO,ZLAT,IOCH)

        IDAT = NINT( Z_DONNEES(21,JO) ) * 10000  +
     &         NINT( Z_DONNEES(22,JO) ) * 100    +
     &         NINT( Z_DONNEES(23,JO) )
        IETM = NINT( Z_DONNEES(24,JO) ) * 10000  +
     &         NINT( Z_DONNEES(25,JO) ) * 100    +
     &         FLOOR( Z_DONNEES(26,JO) )

        IF ( Z_DONNEES(12,JO).NE.RABSI ) THEN
          IINDIC = NINT( Z_DONNEES(12,JO) )
          WRITE (CLINDIC(8:10),'(I3.3)') IINDIC
          ILPREND = 0
          DO JSAT=1,MNBSATSEL(N_TOVSHIRS)
            IF ( IINDIC.EQ.MNOSATSEL(N_TOVSHIRS,JSAT) ) ILPREND = 1
          ENDDO
          IF ( ILPREND.EQ.0 .OR. ILSAUTE.EQ.1 ) THEN
            ILYEST = 0
            DO JSAT=1,I_NB_SAT_OUT
              IF ( CLINDIC(8:10).EQ.CLSATOUT(JSAT) ) ILYEST = JSAT
            ENDDO
            IF ( ILYEST.EQ.0 ) THEN
              I_NB_SAT_OUT = I_NB_SAT_OUT + 1
              IF ( I_NB_SAT_OUT.LE.10 ) THEN
                CLSATOUT(I_NB_SAT_OUT)  = CLINDIC(8:10)
                INBSATOUT(I_NB_SAT_OUT) = 1
              ENDIF
            ELSE IF ( ILYEST.LE.10 ) THEN
              INBSATOUT(ILYEST) = INBSATOUT(ILYEST) + 1
            ENDIF
            CYCLE BOUCLE_MESSAGE
          ENDIF
          ILENVE = 0
          DO JNST=1,INUMST
            IF ( IINDIC.EQ.INOSAT(JNST) ) ILENVE = JNST
          ENDDO
          IF ( ILENVE.EQ.0 ) THEN
            INUMST = INUMST + 1
            ILENVE = INUMST
            INOSAT(INUMST) = IINDIC
          ENDIF
        ELSE
          CYCLE BOUCLE_MESSAGE
        ENDIF

        IF ( Z_DONNEES(10,JO).NE.RABSI )
     &    ISTD = INT(Z_DONNEES(10,JO)+REPSILON)

!  informations auxiliaires

! info 1  NCMSSIA, NCMSCLA, NCMFOVA

        IVNM(1) = NVNUMB(59)
        IF ( Z_DONNEES(13,JO).NE.RABSI ) 
     &    ZPOB(1) = Z_DONNEES(13,JO)  
        IF ( Z_DONNEES(16,JO).NE.RABSI )
     &    ZPRL(1) = Z_DONNEES(16,JO)
        IF ( Z_DONNEES(17,JO).NE.RABSI )
     &    ZVAR(1) = Z_DONNEES(17,JO)

! info 2  NCMSTHA, NCMSAZA, NCMSABA

        IVNM(2) = NVNUMB(59)
        IF ( Z_DONNEES(29,JO).NE.RABSI )
     &    ZPOB(2) = Z_DONNEES(29,JO)
        IF ( Z_DONNEES(30,JO).NE.RABSI )
     &    ZPRL(2) = Z_DONNEES(30,JO)
        IF ( Z_DONNEES(31,JO).NE.RABSI )
     &    ZVAR(2) = Z_DONNEES(31,JO)

! info 3  NCMSOZA, NCMSOBA

        IVNM(3) = NVNUMB(59)
        IF ( Z_DONNEES(32,JO).NE.RABSI )
     &    ZPOB(3) = Z_DONNEES(32,JO)
        IF ( Z_DONNEES(33,JO).NE.RABSI )
     &    ZPRL(3) = Z_DONNEES(33,JO)

        INBP = 3

!  Saisie des wagons

!  composition du code qualite (IFLG) :

!     bits 1 et 2   code qualite coordonnee verticale
!     bits 3 et 4   code qualite parametre mesure
!     bit    16     coordonnee verticale : numero de canal

        ICQCV = 3
        ICQPA = 3
        DO JTB=1,19
          IF ( .NOT.LTHIRSTB(JTB) ) CYCLE
          ID = 42 + (JTB-1)*6
          IF ( Z_DONNEES(ID+6,JO).NE.RABSI ) THEN
            INBP = INBP + 1
            IVNM(INBP) = NVNUMB(50)
            ZPOB(INBP) = Z_DONNEES(ID+1,JO)
            ZPRL(INBP) = RABSO
            ZVAR(INBP) = Z_DONNEES(ID+6,JO)
            ICQPA      = 3
            IFLG(INBP) = 0
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV,1)
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA,3)
            IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,16)
          ENDIF
        ENDDO
        INLV = INBP
        IRLN = NCILET + INLV*NCILBO

!  Copie de l'observation sur le fichier d'obs.

        IF ( INBP.GT.3 ) THEN
          INBRETOT       = INBRETOT + 1
          INBSAT(ILENVE) = INBSAT(ILENVE) + 1

           write(wagon,fmt=wagon_prov) INBP
	   fmt_final = trim(adjustl(entete))//trim(adjustl(wagon))//")"

          WRITE (NULOBI,fmt_final) IRLN,IOTP,IOCH,ZLAT,ZLON,CLINDIC,
     &                     IDAT,IETM,ZALT,INLV,IRFL,ISTD,
     &                     (IVNM(J),ZPOB(J),ZPRL(J),ZVAR(J),
     &                     IFLG(J),J=1,INBP)
          KNBMECR = KNBMECR + 1
          KNBWAG  = KNBWAG + INBP
          IF ( L_GEOPOINTS ) 
     &      WRITE (NULGEO,'(F11.5,F11.5,I5)') ZLON,ZLAT,IINDIC
        ENDIF

      ENDDO BOUCLE_MESSAGE

!-----------------------------------------------------------------------

      WRITE (NULOUT,201) CLPROD,CLSOUL,INBEXTOT,INBRETOT
      DO JNST=1,INUMST
        WRITE (NULOUT,202) INOSAT(JNST),INBSAT(JNST)
      ENDDO
      WRITE (NULOUT,203)
      DO J=1,10
        IF ( INBSATOUT(J).GT.0 )
     &    WRITE (CLNBSATOUT(J),'(I6)') INBSATOUT(J)
      ENDDO
      IF ( I_NB_SAT_OUT.GT.0 ) WRITE (NULOUT,204) CLSATOUT,CLNBSATOUT

 201  FORMAT(/,'     Extraction des donnees TOVSHIRS ',A9,/,5X,32('-'),
     &  A9,//,' Nombre messages extraits   : ',I6,/,' Nombre messages',
     &  ' retenus    : ',I6,/)
 202  FORMAT(' Satellite :  ',I3,6X,I6,' messages')
 203  FORMAT(/)
 204  FORMAT(/,' Satellites extraits, non retenus : ',10(3X,A3,2X),/,
     &       36X,10(A6,2X))

!-----------------------------------------------------------------------

      RETURN
      END
